



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[模板] 数学基础:快速幂/乘/逆元/exGCD/(ex)CRT/(ex)Lucas定理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[模板] 数学基础:快速幂/乘/逆元/exGCD/(ex)CRT/(ex)Lucas定理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 06:45:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>方便复制</p>
<h2>快速乘/幂</h2>
<p>时间复杂度 \(O(\log n)\).</p>
<pre class="prettyprint linenums"><code>ll nmod;<br />
//快速乘<br />
ll qmul(ll a,ll b){<br />
	ll l=a*(b&gt;&gt;hb)%nmod*(1ll&lt;&lt;hb)%nmod;<br />
	ll r=a*(b&amp;((1&lt;&lt;hb)-1))%nmod;<br />
	return (l+r)%nmod;<br />
}<br />
//快速幂<br />
ll qpow(ll a,ll b){<br />
	ll res=1;<br />
	while(b){<br />
		if(b&amp;1)res=res*a%nmod;<br />
		a=a*a%nmod;<br />
		b&gt;&gt;=1;<br />
	}<br />
	return res;<br />
}<br />
</code></pre>
<h2>exgcd</h2>
<h3>内容</h3>
<p>解不定方程 $ ax+by = c $</p>
<p>时间复杂度 \(O(\log n)\).</p>
<pre class="prettyprint linenums"><code>void exgcd(ll a,ll b,ll&amp; x,ll&amp; y,ll&amp; d){ //a&amp;b should &gt; 0<br />
    b==0?(x=1,y=0,d=a):(exgcd(b,a%b,y,x,d),y-=x*(a/b));<br />
}<br />
//use<br />
	ll a,b,c;<br />
	ll m,x,y;<br />
	exgcd(a,b,x,y,m);<br />
	if(c%m!=0)cout&lt;&lt;&quot;No\n&quot;; //无解<br />
	else{<br />
		c/=m,x*=c,y*=c,a/=m,b/=m;<br />
//令x取最小非负整数<br />
		x1=x%b;if(x1&lt;0)x1+=abs(b);<br />
		y1=(c-a*x1)/b;<br />
//令y取最小非负整数<br />
		y1=y%a;if(y1&lt;0)y1+=abs(a);//(y&gt;=0?y%a:y%a+abs(a));<br />
		x1=(c-b*y1)/a;<br />
	}<br />
</code></pre>
<h2>逆元</h2>
<h3>内容</h3>
<p>求\(n * x \equiv 1 (mod m)\) 最小正整数解.</p>
<h3>单个数</h3>
<p>时间复杂度 \(O(\log n)\).</p>
<pre class="prettyprint linenums"><code>//1:qp(n,nmod-2)<br />
//2<br />
ll getv(ll n){return n&lt;0?n+nmod:n;}<br />
ll inv(ll n){<br />
    ll x,y,d;<br />
    exgcd(getv(n%nmod),p,x,y,d);<br />
    return x%p+(x&lt;0?p:0);<br />
}<br />
</code></pre>
<h3>线性求逆元</h3>
<p>时间复杂度 \(O(n)\).</p>
<ol><li>公式法(并不能记住板子)</li>
<li>阶乘法<br /><br />
利用下面的公式:</li></ol>
<p><div>\[(n!)^{-1} = ((n+1)!)^{-1} \cdot (n+1)<br />
\]</div></p>
<p><div>\[n^{-1} = (n!)^{-1} \cdot (n-1)!<br />
\]</div></p>
<h4>代码</h4>
<pre class="prettyprint linenums"><code>ll fac[nsz],ifac[nsz];<br />
void init(int bnd){<br />
	fac[0]=1;<br />
	rep(i,1,bnd)fac[i]=i*fac[i-1]%nmod;<br />
	ifac[bnd]=inv(fac[bnd]);<br />
	repdo(i,bnd-1,0){<br />
		ifac[i]=ifac[i+1]*(i+1)%nmod;<br />
	}<br />
}<br />
</code></pre>
<h2>CRT</h2>
<p><a href="https://blog.csdn.net/niiick/article/details/80229217" rel="external nofollow noreferrer">中国剩余定理 &amp;&amp; 扩展中国剩余定理 - niiick - CSDN博客</a></p>
<h3>内容</h3>
<p>解线性同余方程组 \(x \equiv a_i \pmod{m_i}, \forall i \in \{1, 2, \cdots , n\}\). 其中\(m_i\)两两互质.</p>
<p>设\(M=\prod_{i=1}^nm_i\), \(M_i=\frac M{m_i}\);<br /><br />
\(M_i^{-1}\) 为 \(M_i\) 关于 \(\bmod m_i\)的逆元,</p>
<p>则可以构造出通解</p>
<p><div>\[ x \equiv \sum_{i=1}^k a_iM_iM_i^{-1} \pmod M $$.</p>
<p>时间复杂度 $O(n \cdot 逆元)$, 通常为 $O(n \log n)$.</p>
<p>### 代码<br />
```<br />
ll crt(ll a,ll m,ll m0){//m0 | m; (m0,m/m0)=1<br />
	return m/m0*inv(m/m0,m0)%m*a%m;<br />
}<br />
```</p>
<p>## excrt<br />
模数不互质.</p>
<p>利用合并的思想求解.</p>
<p>时间复杂度$O(n \log n)$.</p>
<p>### 代码<br />
```<br />
ll excrt(ll *a,ll *m,ll n){<br />
	ll a0=a[1],m0=m[1],x,y,g;<br />
	rep(i,2,n){<br />
		g=exgcd(m0,m[i],x,y);<br />
		if((a[i]-a0)%g!=0)return -1;<br />
		x=(a[i]-a0)/g*x%(m[i]/g);<br />
		a0+=x*m0;<br />
		m0=m0/g*m[i];<br />
		a0%=m0;<br />
	}<br />
	return a0&lt;0?(a0%m0+m0):(a0%m0);<br />
}<br />
```<br />
## Lucas定理<br />
[Lucas定理 - permui - 博客园](https://www.cnblogs.com/owenyu/p/6724560.html)<br />
### 内容<br />
求 $\binom n m \bmod p$, 保证$p \in \{ prime \}$.</p>
<p>设$n=(a_0a_1\dots a_k)_p$, $m=(b_0b_1\dots b_k)_p$, 有<br />
$$ \binom n m\equiv \prod _{i=0}^k\binom {a_i} {b_i} \pmod p \]</p></div></p>
<p>也即</p>
<p><div>\[\binom n m \equiv \binom {\lfloor \frac{n}{p}\rfloor} {\lfloor \frac{m}{p}\rfloor} \cdot \binom {n \bmod p} {m \bmod p} \pmod p<br />
\]</div></p>
<p>递归求解.</p>
<p>时间复杂度 \(O(p \log_p n)\) , 或者 \(O(p)\) 预处理, \(O(\log_p n)\) 单次询问.</p>
<h3>代码</h3>
<pre class="prettyprint linenums"><code>ll c(ll n,ll m){<br />
    if(m&lt;0||m&gt;n)return 0;<br />
    return fact(n)*inv(fact(m)*fact(n-m)%p)%p;<br />
}<br />
ll lucas(int n,int m){//c(n,m)%p<br />
    return m?lucas(n/p,m/p)*c(n%p,m%p)%p:1;<br />
}<br />
</code></pre>
<h2>exLucas</h2>
<p><a href="https://blog.csdn.net/hqddm1253679098/article/details/82897638" rel="external nofollow noreferrer">【知识总结】扩展卢卡斯定理（exLucas） - Inspector_Javert - CSDN博客</a></p>
<p>p为合数.</p>
<p>分解质因数+阶乘取模+组合数+excrt</p>
<p>注意如果计算 \(n! \bmod p^k\) 时如果计算 \(p^x\) 对结果的贡献, 将无法求逆元. 因此需要求 \(\frac{n!}{p^x} \bmod p^k\), 即忽略p的幂, 然后在求组合数时再乘回来.</p>
<p>码量++</p>
<p>复杂度太长... 当它是 \(O(p \log p)\) 好惹</p>
<h3>代码</h3>
<pre class="prettyprint linenums"><code>ll qpow(ll a,ll b,ll nmod){<br />
    ll res=1;<br />
    while(b){<br />
        if(b&amp;1)res=res*a%nmod;<br />
        a=a*a%nmod;<br />
        b&gt;&gt;=1;<br />
    }<br />
    return res;<br />
}

void exgcd(ll a,ll b,ll &amp;x,ll &amp;y,ll &amp;d){<br />
	b?(exgcd(b,a%b,y,x,d),y-=x*(a/b)):(x=1,y=0,d=a);<br />
}<br />
ll inv(ll a,ll m){<br />
	ll x,y,d;<br />
	exgcd(a,m,x,y,d);<br />
	return x&gt;=0?x%m:x%m+m;<br />
}<br />
ll crt(ll a,ll m,ll m0){//m0 | m; (m0,m/m0)=1<br />
	return m/m0*inv(m/m0,m0)%m*a%m;<br />
}

ll fact(ll n,ll p,ll pk){//(n!/p^x)%(p^k)<br />
	if(n&lt;=1)return 1;<br />
	ll ans=1,tmp=n%pk;<br />
	rep(i,1,pk){<br />
		if(i%p)ans=ans*i%pk;<br />
	}<br />
	ans=qpow(ans,n/pk,pk);<br />
	rep(i,1,tmp){<br />
		if(i%p)ans=ans*i%pk;<br />
	}<br />
	return ans*fact(n/p,p,pk)%pk;<br />
}

ll c(ll n,ll m,ll p,ll pk){//c(n,m)%(p^k)<br />
	ll sum=0;<br />
	for(ll i=n;i;i/=p)sum+=i/p;<br />
	for(ll i=m;i;i/=p)sum-=i/p;<br />
	for(ll i=n-m;i;i/=p)sum-=i/p;<br />
	return qpow(p,sum,pk)*fact(n,p,pk)%pk*inv(fact(m,p,pk),pk)%pk*inv(fact(n-m,p,pk),pk)%pk;<br />
}

ll fac[40][2],pf; //0 p;  1 pk<br />
void getfac(ll n){<br />
	ll tmp=sqrt(n);<br />
	rep(i,2,tmp){<br />
		if(n%i==0){<br />
			fac[++pf][0]=i,fac[pf][1]=1;<br />
			while(n%i==0)n/=i,fac[pf][1]*=i;<br />
		}<br />
	}<br />
	if(n&gt;1)fac[++pf][0]=n,fac[pf][1]=n;<br />
}<br />
ll exlucas(ll n,ll m,ll p){<br />
	ll ans=0;<br />
	getfac(p);<br />
	rep(i,1,pf){<br />
		ans=(ans+crt(c(n,m,fac[i][0],fac[i][1]),p,fac[i][1]))%p;<br />
	}<br />
	return ans;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvpejxq.html">&period;net学习之Attribute特性和EF关键知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw7d338.html">hdu How to Type</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xpyr09.html">No valid host was found&period; There are not enough hosts available</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjp71k9.html">MongoDB中通过MapReduce实现合计Sum功能及返回格式不一致问题分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wxypvq.html">10 signs you&rsquo;re dating the wrong person</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvz73zq.html">转】Mahout分步式程序开发 聚类Kmeans</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12kw39.html">【转】 Nginx系列（一）--nginx是什么？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjv6lk9.html">OpenJudge 2738 浮点数加法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm72y69.html">Yii防注入攻击笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xejp08.html">在 Windows 下远程桌面连接 Linux - XManager 篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/950p6re8.html">strut1&period;X和spring整合的二种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljv5je9.html">Android hook神器frida（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m4plo8.html">shell脚本编程基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1nl5gq.html">javascript学习（4）异常处理 try-catch 和 onerror</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojmll1q.html">关于WEB-INF目录下的静态资源（js、css、img）的访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2r1dj9.html">linux 学习笔记 ftp</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em01yx9.html">WinForm创建自定义控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kmpz479.html">CentOS下Docker与&period;netcore&lpar;三）之 三剑客之一Docker-Compose</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvdd30xq.html">BZOJ4827：&lbrack;AH2017&sol;HNOI2017&rsqb;礼物&mdash;&mdash;题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pm7mpz9.html">React &plus; Dva &plus; Antd &plus; Umi 概况</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7z63nk9.html">iview-admin框架运行步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k02o29.html">20190328-CSS样式一：字体样式font-、文本样式text-、背景图样式background-</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z631e9.html">PHP实现微信随机红包算法和微信红包的架构设计简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zodx5xq.html">js中函数表达式和自执行函数表达式的用法总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge26ez8.html">&period;NET的未来-广州&period;NET俱乐部学生分会</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzw4348.html">aspnetcoremodule 2&period;1下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ye25w8.html">&lbrack;20190415&rsqb;11g下那些latch是共享的&period;txt</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv16lkjq.html">Linux Shell 返回值之 PIPESTATUS</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd0rvd9.html">mybatis配置文件说明（configuration）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojzz71q.html">springboot mybatis搭建</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
